---
 confdb/aclocal_atomic.m4 |   24 +-
 confdb/aclocal_cache.m4  |   10 
 confdb/aclocal_cc.m4     |    4 
 confdb/aclocal_shl.m4    |    6 
 configure.in             |  563 ++++++++++++++++++++++++-----------------------
 5 files changed, 321 insertions(+), 286 deletions(-)

Index: confdb/aclocal_atomic.m4
===================================================================
--- confdb/aclocal_atomic.m4.orig	2010-09-16 21:55:56.000000000 +0200
+++ confdb/aclocal_atomic.m4	2014-05-07 21:12:15.458390737 +0200
@@ -50,7 +50,7 @@ int main(int argc, char **argv)
 pac_cv_have_gcc_asm_and_x86_sfence=yes,pac_cv_have_gcc_asm_and_x86_sfence=no)])
 
 if test "$pac_cv_have_gcc_asm_and_x86_sfence" = "yes" ; then
-    AC_DEFINE(HAVE_GCC_ASM_AND_X86_SFENCE, 1, [Define if using gcc on a x86 system with the sfence instruction])
+    AC_DEFINE([HAVE_GCC_ASM_AND_X86_SFENCE], 1, [Define if using gcc on a x86 system with the sfence instruction])
 fi
 
 AC_CACHE_CHECK([for x86 lfence instruction using __asm__],
@@ -65,7 +65,7 @@ int main(int argc, char **argv)
 pac_cv_have_gcc_asm_and_x86_lfence=yes,pac_cv_have_gcc_asm_and_x86_lfence=no)])
 
 if test "$pac_cv_have_gcc_asm_and_x86_lfence" = "yes" ; then
-    AC_DEFINE(HAVE_GCC_ASM_AND_X86_LFENCE, 1, [Define if using gcc on a x86 system with the lfence instruction])
+    AC_DEFINE([HAVE_GCC_ASM_AND_X86_LFENCE], 1, [Define if using gcc on a x86 system with the lfence instruction])
 fi
 
 dnl Some compilers, like icc, may want __asm _emit
@@ -81,7 +81,7 @@ int main(int argc, char **argv)
 pac_cv_have___asm_and_x86_mfence=yes,pac_cv_have___asm_and_x86_mfence=no)])
 
 if test "$pac_cv_have___asm_and_x86_mfence" = "yes" ; then
-    AC_DEFINE(HAVE___ASM_AND_X86_MFENCE, 1, [Define if using __asm on a x86 system with the mfence instruction])
+    AC_DEFINE([HAVE___ASM_AND_X86_MFENCE], 1, [Define if using __asm on a x86 system with the mfence instruction])
 fi
 
 AC_CACHE_CHECK([for x86 sfence instruction using __asm],
@@ -111,7 +111,7 @@ int main(int argc, char **argv)
 pac_cv_have___asm_and_x86_lfence=yes,pac_cv_have___asm_and_x86_lfence=no)])
 
 if test "$lac_cv_have___asm_and_x86_lfence" = "yes" ; then
-    AC_DEFINE(HAVE___ASM_AND_X86_LFENCE, 1, [Define if using __asm on a x86 system with the lfence instruction])
+    AC_DEFINE([HAVE___ASM_AND_X86_LFENCE], 1, [Define if using __asm on a x86 system with the lfence instruction])
 fi
 
 dnl 
@@ -131,7 +131,7 @@ int main(int argc, char **argv)
 pac_cv_have_asm_and_x86_mfence=yes,pac_cv_have_asm_and_x86_mfence=no)])
 
 if test "$pac_cv_have_asm_and_x86_mfence" = "yes" ; then
-    AC_DEFINE(HAVE_ASM_AND_X86_MFENCE, 1, [Define if using asm() on a x86 system with the mfence instruction])
+    AC_DEFINE([HAVE_ASM_AND_X86_MFENCE], 1, [Define if using asm() on a x86 system with the mfence instruction])
 fi
 
 AC_CACHE_CHECK([for x86 sfence instruction using asm()],
@@ -146,7 +146,7 @@ int main(int argc, char **argv)
 pac_cv_have_asm_and_x86_sfence=yes,pac_cv_have_asm_and_x86_sfence=no)])
 
 if test "$pac_cv_have_asm_and_x86_sfence" = "yes" ; then
-    AC_DEFINE(HAVE_ASM_AND_X86_SFENCE, 1, [Define if using asm() on a x86 system with the sfence instruction])
+    AC_DEFINE([HAVE_ASM_AND_X86_SFENCE], 1, [Define if using asm() on a x86 system with the sfence instruction])
 fi
 
 AC_CACHE_CHECK([for x86 lfence instruction using asm()],
@@ -161,7 +161,7 @@ int main(int argc, char **argv)
 pac_cv_have_asm_and_x86_lfence=yes,pac_cv_have_asm_and_x86_lfence=no)])
 
 if test "$pac_cv_have_asm_and_x86_lfence" = "yes" ; then
-    AC_DEFINE(HAVE_ASM_AND_X86_LFENCE, 1, [Define if using asm() on a x86 system with the lfence instruction])
+    AC_DEFINE([HAVE_ASM_AND_X86_LFENCE], 1, [Define if using asm() on a x86 system with the lfence instruction])
 fi
 
 AC_CACHE_CHECK([for _InterlockedExchange intrinsic],
@@ -178,7 +178,7 @@ int main(int argc, char **argv)
 pac_cv_have__InterlockedExchange=yes,pac_cv_have__InterlockedExchange=no)])
 
 if test "$pac_cv_have__InterlockedExchange" = "yes" ; then
-    AC_DEFINE(HAVE__INTERLOCKEDEXCHANGE, 1, [Define if _InterlockedExchange intrinsic is available])
+    AC_DEFINE([HAVE__INTERLOCKEDEXCHANGE], 1, [Define if _InterlockedExchange intrinsic is available])
 fi
 
 AC_CACHE_CHECK([for SPARC membar instruction with gcc],
@@ -189,7 +189,7 @@ int main(int argc, char **argv){
     exit(0);
 }],pac_cv_gcc_sparc_membar=yes,pac_cv_gcc_sparc_membar=no)])
 if test "$pac_cv_gcc_sparc_membar" = yes ; then
-    AC_DEFINE(HAVE_GCC_ASM_SPARC_MEMBAR,1,[Define if gcc asm membar supported])
+    AC_DEFINE([HAVE_GCC_ASM_SPARC_MEMBAR],1,[Define if gcc asm membar supported])
 fi
 
 AC_CACHE_CHECK([for SPARC membar instruction with Solaris C],
@@ -200,7 +200,7 @@ int main(int argc, char **argv){
     exit(0);
 }],pac_cv_solaris_sparc_membar=yes,pac_cv_solaris_sparc_membar=no)])
 if test "$pac_cv_solaris_sparc_membar" = yes ; then
-    AC_DEFINE(HAVE_SOLARIS_ASM_SPARC_MEMBAR,1,[Define if solaris asm membar supported])
+    AC_DEFINE([HAVE_SOLARIS_ASM_SPARC_MEMBAR],1,[Define if solaris asm membar supported])
 fi
 
 AC_CACHE_CHECK([for SPARC stbar instruction with gcc],
@@ -211,7 +211,7 @@ int main(int argc, char **argv){
     exit(0);
 }],pac_cv_gcc_sparc_stbar=yes,pac_cv_gcc_sparc_stbar=no)])
 if test "$pac_cv_gcc_sparc_stbar" = yes ; then
-    AC_DEFINE(HAVE_GCC_ASM_SPARC_STBAR,1,[Define if gcc asm stbar supported])
+    AC_DEFINE([HAVE_GCC_ASM_SPARC_STBAR],1,[Define if gcc asm stbar supported])
 fi
 
 AC_CACHE_CHECK([for SPARC stbar instruction with Solaris C],
@@ -222,6 +222,6 @@ int main(int argc, char **argv){
     exit(0);
 }],pac_cv_solaris_sparc_stbar=yes,pac_cv_solaris_sparc_stbar=no)])
 if test "$pac_cv_solaris_sparc_stbar" = yes ; then
-    AC_DEFINE(HAVE_SOLARIS_ASM_SPARC_STBAR,1,[Define if solaris asm stbar supported])
+    AC_DEFINE([HAVE_SOLARIS_ASM_SPARC_STBAR],1,[Define if solaris asm stbar supported])
 fi
 ])
\ No newline at end of file
Index: confdb/aclocal_cache.m4
===================================================================
--- confdb/aclocal_cache.m4.orig	2010-09-16 21:55:56.000000000 +0200
+++ confdb/aclocal_cache.m4	2014-05-07 21:14:18.312554309 +0200
@@ -174,8 +174,8 @@ dnl Add this call to the other ARG_ENABL
 dnl set here are redundant; the LOAD_CACHE call relies on the way autoconf
 dnl initially processes ARG_ENABLE commands.
 AC_DEFUN([PAC_ARG_CACHING],[
-AC_ARG_ENABLE(cache,
-[--enable-cache  - Turn on configure caching],
+AC_ARG_ENABLE([cache],
+              AS_HELP_STRING([--enable-cache], [Turn on configure caching]),
 enable_cache="$enableval",enable_cache="notgiven")
 ])
 dnl
@@ -328,9 +328,9 @@ dnl cachefile before the the end of the
 dnl cause problems.
 dnl
 AC_DEFUN([PAC_CREATE_BASE_CACHE],[
-AC_ARG_ENABLE(base-cache,
-[--enable-base-cache - Enable the use of a simple cache for the subsidieary
-                       configure scripts.],,enable_base_cache=default)
+AC_ARG_ENABLE([base-cache],
+AS_HELP_STRING([--enable-base-cache], [Enable the use of a simple cache for the subsidieary configure scripts.])
+,,enable_base_cache=default)
 # The default case is controlled by the environment variable CONF_USE_CACHEFILE
 if test "$enable_base_cache" = "default" ; then
     if test "$CONF_USE_CACHEFILE" = yes ; then
Index: confdb/aclocal_cc.m4
===================================================================
--- confdb/aclocal_cc.m4.orig	2010-09-16 21:55:56.000000000 +0200
+++ confdb/aclocal_cc.m4	2014-05-07 21:16:04.104111917 +0200
@@ -24,7 +24,7 @@ dnl 2.52 doesn't have AC_PROG_CC_GNU
 ifdef([AC_PROG_CC_GNU],,[AC_DEFUN([AC_PROG_CC_GNU],)])
 AC_DEFUN([PAC_PROG_CC],[
 AC_PROVIDE([AC_PROG_CC])
-AC_CHECK_PROGS(CC, cc xlC xlc pgcc icc pathcc gcc )
+AC_CHECK_PROGS([CC], cc xlC xlc pgcc icc pathcc gcc )
 test -z "$CC" && AC_MSG_ERROR([no acceptable cc found in \$PATH])
 PAC_PROG_CC_WORKS
 AC_PROG_CC_GNU
@@ -141,7 +141,7 @@ dnl optimization.
 dnl D*/
 AC_DEFUN([PAC_C_OPTIMIZATION],[
     for copt in "-O4 -Ofast" "-Ofast" "-fast" "-O3" "-xO3" "-O" ; do
-        PAC_C_CHECK_COMPILER_OPTION($copt,found_opt=yes,found_opt=no)
+        PAC_C_CHECK_COMPILER_OPTION([$copt],[found_opt=yes],[found_opt=no])
         if test "$found_opt" = "yes" ; then
 	    ifelse($1,,COPTIONS="$COPTIONS $copt",$1)
 	    break
Index: confdb/aclocal_shl.m4
===================================================================
--- confdb/aclocal_shl.m4.orig	2010-09-16 21:55:56.000000000 +0200
+++ confdb/aclocal_shl.m4	2014-05-07 21:21:55.132008415 +0200
@@ -63,14 +63,14 @@ dnl will probably be defined, including
 dnl search paths are specified and how shared library names are set.
 dnl D*/
 AC_DEFUN([PAC_ARG_SHAREDLIBS],[
-AC_ARG_ENABLE(sharedlibs,
-[--enable-sharedlibs=kind - Enable shared libraries.  kind may be
+AC_ARG_ENABLE([sharedlibs],
+AS_HELP_STRING([--enable-sharedlibs=kind], [Enable shared libraries.  kind may be
     gcc     - Standard gcc and GNU ld options for creating shared libraries
     osx-gcc - Special options for gcc needed only on OS/X
     solaris-cc - Solaris native compilers
     cygwin-gcc - Special options for gcc needed only for cygwin
     none    - same as --disable-sharedlibs
-Only gcc, osx-gcc, and solaris-cc are currently supported],
+Only gcc, osx-gcc, and solaris-cc are currently supported]),
 ,enable_sharedlibs=none;enable_shared=no)
 dnl
 CC_SHL=true
Index: configure.in
===================================================================
--- configure.in.orig	2010-09-16 21:55:56.000000000 +0200
+++ configure.in	2014-05-07 20:33:53.387462635 +0200
@@ -123,14 +123,14 @@ dnl Note that no executable statements a
 dnl dropped) before AC_INIT.
 dnl
 
-AC_INIT(src/include/mpichconf.h.in)
+AC_INIT([src/include/mpichconf.h.in])
 
-CONFIGURE_ARGS_CLEAN=`echo $* | tr '"' ' '`
-AC_SUBST(CONFIGURE_ARGS_CLEAN)
+CONFIGURE_ARGS_CLEAN=$(echo $* | tr '"' ' ')
+AC_SUBST([CONFIGURE_ARGS_CLEAN])
 
 # Try to find the release date
 if test -s "$srcdir/maint/ReleaseDate" ; then
-    RELEASE_DATE="`cat $srcdir/maint/ReleaseDate`"
+    RELEASE_DATE="$(cat $srcdir/maint/ReleaseDate)"
 else
 dnl <_OSU_MVAPICH_>
 dnl    RELEASE_DATE="Unknown, built on `date`"
@@ -141,7 +141,7 @@ AC_SUBST(RELEASE_DATE)
 
 # Try to find the version
 if test -s "$srcdir/maint/Version" ; then
-    MPICH2_VERSION="`cat $srcdir/maint/Version | grep ^MPICH2_VERSION: | cut -f2 -d' '`"
+    MPICH2_VERSION="$(cat $srcdir/maint/Version | grep ^MPICH2_VERSION: | cut -f2 -d' ')"
     export MPICH2_VERSION
 else
     AC_MSG_ERROR([Version information not found. Configuration aborted.])
@@ -166,11 +166,11 @@ fi
 # Numeric version will have 1 digit for MAJ, 2 digits for MIN,
 # 2 digits for REV, 1 digit for EXT and 2 digits for EXT_NUMBER.
 changequote(<<,>>)
-V1=`expr $MPICH2_VERSION : '\([0-9]*\)\.[0-9]*\.*[0-9]*[a-zA-Z]*[0-9]*'`
-V2=`expr $MPICH2_VERSION : '[0-9]*\.\([0-9]*\)\.*[0-9]*[a-zA-Z]*[0-9]*'`
-V3=`expr $MPICH2_VERSION : '[0-9]*\.[0-9]*\.*\([0-9]*\)[a-zA-Z]*[0-9]*'`
-V4=`expr $MPICH2_VERSION : '[0-9]*\.[0-9]*\.*[0-9]*\([a-zA-Z]*\)[0-9]*'`
-V5=`expr $MPICH2_VERSION : '[0-9]*\.[0-9]*\.*[0-9]*[a-zA-Z]*\([0-9]*\)'`
+V1=$(expr $MPICH2_VERSION : '\([0-9]*\)\.[0-9]*\.*[0-9]*[a-zA-Z]*[0-9]*')
+V2=$(expr $MPICH2_VERSION : '[0-9]*\.\([0-9]*\)\.*[0-9]*[a-zA-Z]*[0-9]*')
+V3=${expr $MPICH2_VERSION : '[0-9]*\.[0-9]*\.*\([0-9]*\)[a-zA-Z]*[0-9]*'}
+V4=$(expr $MPICH2_VERSION : '[0-9]*\.[0-9]*\.*[0-9]*\([a-zA-Z]*\)[0-9]*')
+V5=$(expr $MPICH2_VERSION : '[0-9]*\.[0-9]*\.*[0-9]*[a-zA-Z]*\([0-9]*\)')
 changequote([,])
 
 if test "$V2" -le 9 ; then V2=0$V2 ; fi
@@ -206,8 +206,8 @@ AC_SUBST(MPICH2_VERSION)
 # Makefile.sm to pass the ABIVERSION to the createshlib script.
 # We use libtool-style version numbers (see --version-info in the 
 # libtool manual)
-ABIVERSION="`cat $srcdir/maint/Version | grep ^MPICH2_ABIVERSION: | cut -f2 -d' '`"
-AC_SUBST(ABIVERSION)
+ABIVERSION="$(cat $srcdir/maint/Version | grep ^MPICH2_ABIVERSION: | cut -f2 -d' ')"
+AC_SUBST([ABIVERSION])
 
 
 CONFIGURE_ARGUMENTS="$ac_configure_args"
@@ -219,11 +219,11 @@ else
 fi
 # Add the information on the system:
 dnl <_OSU_MVAPICH_>
-dnl echo "Running on system: `uname -a`"
+dnl echo "Running on system: $(uname -a)"
 dnl </_OSU_MVAPICH_>
 dnl
 dnl Definitions will be placed in this file rather than in the DEFS variable
-AC_CONFIG_HEADER(src/include/mpichconf.h)
+AC_CONFIG_HEADER([src/include/mpichconf.h])
 AH_TOP([/* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* Copyright (c) 2003-2010, The Ohio State University. All rights
  * reserved.
@@ -248,7 +248,7 @@ AH_BOTTOM([#endif])
 dnl
 dnl Set the directory that contains support scripts such as install-sh and
 dnl config.guess
-AC_CONFIG_AUX_DIR(confdb)
+AC_CONFIG_AUX_DIR([confdb])
 dnl <_OSU_MVAPICH_>
 AC_CANONICAL_BUILD
 dnl </_OSU_MVAPICH_>
@@ -259,67 +259,79 @@ dnl
 dnl Enable better caching control
 PAC_ARG_CACHING
 dnl
-AC_ARG_ENABLE(echo, 
-[--enable-echo  - Turn on strong echoing. The default is enable=no.] ,set -x)
-dnl
-dnl
-AC_ARG_ENABLE(coverage,
-[--enable-coverage - Turn on coverage analysis using gcc and gcov],,
-enable_coverage=no)
-dnl
-AC_ARG_ENABLE(dynamiclibs,
-[--enable-dynamiclibs - Enable the use of dynamic libraries by the devices
-                       that support them],,enable_dynamiclibs=no)
-dnl
-AC_ARG_ENABLE(error-checking,
-[--enable-error-checking=level - Control the amount of error checking.  
-    no        - no error checking
-    runtime   - error checking controllable at runtime through environment 
-                variables
-    all       - error checking always enabled],,enable_error_checking=all)
-dnl
-AC_ARG_ENABLE(error-messages,
-[--enable-error-messages=level - Control the amount of detail in error messages.
-    all       - Maximum amount of information
-    generic   - Only generic messages (no information about the specific
-                instance)
-    class     - One message per MPI error class
-    none      - No messages],,enable_error_messages=all)
-dnl
-AC_ARG_ENABLE(timing,
-[--enable-timing=level - Control the amount of timing information
-                        collected by the MPICH implementation.
-    none    - Collect no data (default)
-    all     - Collect lots of data
-    runtime - Runtime control of data collected]
-  ,,enable_timing=default)
-dnl
-AC_ARG_ENABLE(g,
-[--enable-g=option - Control the level of debugging support in the
-                    MPICH implementation.  option is a list of comma
-                    separated names including
-    none     - No debugging
-    handle   - Trace handle operations
-    handlealloc - Trace hancle allocations
-    dbg      - Add compiler flag, -g, to all internal
-               compiler flags, i.e. MPICH2LIB_CFLAGS, MPICH2LIB_CXXFLAGS,
-               MPICH2LIB_FFLAGS, and MPICH2LIB_F90FLAGS.
-    debug    - Synonym for dbg
-    log      - Enable debug event logging
-    mem      - Memory usage tracing
-    meminit  - Preinitialize memory associated structures and unions to
-               eliminate access warnings from programs like valgrind
-    memarena - Check for overwrite errors in memory allocation arena
-    mutex    - Enable error checking on pthread mutexes
-    mutexnesting - Check for non-nesting of mutexes
-    nesting  - Check for proper nesting values
-    fine-grain-nesting - Perform a fine-grain nesting check on exit
-    all      - All of the above choices],,enable_g=none)
+AC_ARG_ENABLE([echo],
+              AS_HELP_STRING([--enable-echo],
+                             [Turn on strong echoing. The default is enable=no.]),
+              set -x)
+dnl
+dnl
+AC_ARG_ENABLE([coverage],
+               AS_HELP_STRING([--enable-coverage],
+                              [Turn on coverage analysis using gcc and gcov]),
+               ,enable_coverage=no)
+dnl
+AC_ARG_ENABLE([dynamiclibs],
+              AS_HELP_STRING([--enable-dynamiclibs],
+                             [Enable the use of dynamic libraries by the devices
+                                that support them]),,enable_dynamiclibs=no)
+dnl
+AC_ARG_ENABLE([error-checking],
+              AS_HELP_STRING([--enable-error-checking=level],
+                             [Control the amount of error checking.
+                              no        - no error checking,
+                              runtime   - error checking controllable at runtime through environment
+                                          variables
+                              all       - error checking always enabled]),
+              ,enable_error_checking=all)
+dnl
+AC_ARG_ENABLE([error-messages],
+              AS_HELP_STRING([--enable-error-messages=level],
+                             [Control the amount of detail in error messages.
+                             all       - Maximum amount of information
+                             generic   - Only generic messages (no information about the specific
+                                         instance)
+                             class     - One message per MPI error class
+                             none      - No messages]),
+              ,enable_error_messages=all)
+dnl
+AC_ARG_ENABLE([timing],
+              AS_HELP_STRING([--enable-timing=level],
+                             [Control the amount of timing information collected by the MPICH implementation.
+                             none    - Collect no data (default)
+                             all     - Collect lots of data
+                             runtime - Runtime control of data collected])
+              ,,enable_timing=default)
+dnl
+AC_ARG_ENABLE([g],
+              AS_HELP_STRING([--enable-g=option],
+                             [Control the level of debugging support in the
+                                MPICH implementation.  option is a list of comma
+                                separated names including
+                             none         - No debugging
+                             handle       - Trace handle operations
+                             handlealloc  - Trace hancle allocations
+                             dbg          - Add compiler flag, -g, to all internal
+                                           compiler flags, i.e. MPICH2LIB_CFLAGS, MPICH2LIB_CXXFLAGS,
+                                           MPICH2LIB_FFLAGS, and MPICH2LIB_F90FLAGS.
+                             debug        - Synonym for dbg
+                             log          - Enable debug event logging
+                             mem          - Memory usage tracing
+                             meminit      - Preinitialize memory associated structures and unions to
+                                            eliminate access warnings from programs like valgrind
+                             memarena     - Check for overwrite errors in memory allocation arena
+                             mutex        - Enable error checking on pthread mutexes
+                             mutexnesting - Check for non-nesting of mutexes
+                             nesting      - Check for proper nesting values
+                             fine-grain-nesting - Perform a fine-grain nesting check on exit
+                             all      - All of the above choices]),,
+              enable_g=none)
 dnl
 dnl We may want to force MPI_Aint to be the same size as MPI_Offset, 
 dnl particularly on 32 bit systems with large (64 bit) file systems.
-AC_ARG_WITH(aint-size,
-[--with-aint-size - Override the size of MPI_AINT (in bytes)],,with_aint_size=0)
+AC_ARG_WITH([aint-size],
+            AS_HELP_STRING([--with-aint-size],
+                           [Override the size of MPI_AINT (in bytes)]),,
+            with_aint_size=0)
 dnl
 dnl
 dnl --enable-sharedlibs=kind is set with the PAC_ARG_SHAREDLIBS macro 
@@ -329,192 +341,212 @@ dnl [--enable-internat - Enable internat
 dnl  Not yet supported])
 dnl
 dnl --enable-fast
-AC_ARG_ENABLE(fast,
-[--enable-fast=option - Control the level of fast execution in the MVAPICH2
-implementation.   option is a list of comma separated names including 
-    defopt   - Standard compiler optimization -O2 for all language bindings,
-               i.e. --enable-fast=O2, when neither --enable-fast
-               nor --disable-fast is specified.
-    O<n>     - Appends default optimization flags, -O<n>, to all internal
-               compiler flags, i.e. MPICH2LIB_CFLAGS, MPICH2LIB_CXXFLAGS,
-               MPICH2LIB_FFLAGS, and MPICH2LIB_F90FLAGS.
-    nochkmsg - No error checking, i.e. --disable-error-checking
-    notiming - No timing collection, i.e. --disable-timing.
-    ndebug   - Appends -DNDEBUG to MPICH2LIB_CFLAGS.
-    all|yes  - "defopt", "nochkmsg", "notiming" and "ndebug" are enabled
-               when --enable-fast is specified without any option. (default)
-    none     - None of above options, i.e. --disable-fast.  Note that 
-    	       --enable-strict will add the -O2 option even if
-	       --enable-fast=none is given.
-],,enable_fast=all)
-
-AC_ARG_ENABLE(check-compiler-flags,
-[--enable-check-compiler-flags -- enable the checks for all compiler
-                                 options, xxxFLAGS, MPICH2_xxxFLAGS.
-                                 Default is on.]
-    ,,enable_check_compiler_flags=yes)
+AC_ARG_ENABLE([fast],
+              AS_HELP_STRING([--enable-fast=option],
+                             [Control the level of fast execution in the MVAPICH2
+                                implementation.   option is a list of comma separated
+                                names including
+                             defopt   - Standard compiler optimization -O2 for all language bindings,
+                                        i.e. --enable-fast=O2, when neither --enable-fast
+                                        nor --disable-fast is specified.
+                             O<n>     - Appends default optimization flags, -O<n>, to all internal
+                                        compiler flags, i.e. MPICH2LIB_CFLAGS, MPICH2LIB_CXXFLAGS,
+                                        MPICH2LIB_FFLAGS, and MPICH2LIB_F90FLAGS.
+                             nochkmsg - No error checking, i.e. --disable-error-checking
+                             notiming - No timing collection, i.e. --disable-timing.
+                             ndebug   - Appends -DNDEBUG to MPICH2LIB_CFLAGS.
+                             all|yes  - "defopt", "nochkmsg", "notiming" and "ndebug" are enabled
+                                        when --enable-fast is specified without any option. (default)
+                             none     - None of above options, i.e. --disable-fast.  Note that
+                                        --enable-strict will add the -O2 option even if
+	                                --enable-fast=none is given.]),,
+	      enable_fast=all)
+
+AC_ARG_ENABLE([check-compiler-flags],
+              AS_HELP_STRING([--enable-check-compiler-flags],
+                             [enable the checks for all compiler options, xxxFLAGS, MPICH2_xxxFLAGS.
+                                 Default is on.]),,
+              enable_check_compiler_flags=yes)
 
 dnl
 dnl We enable f77 and f90 if we can find compilers for them.
 dnl In addition, we check whether f77 and f90 can work together.
 dnl
-AC_ARG_ENABLE(f77,
-[--enable-f77 - Enable Fortran 77 bindings],,
-enable_f77=default; enable_f77_wasdefault=yes)
-AC_ARG_ENABLE(f90,
-[--enable-f90 - Enable Fortran 90 bindings],,enable_f90=default)
-AC_ARG_ENABLE(cxx,
-[--enable-cxx - Enable C++ bindings],,enable_cxx=default)
-AC_ARG_ENABLE(romio,
-[--enable-romio - Enable ROMIO MPI I/O implementation],
-,enable_romio=yes)
-dnl
-AC_ARG_ENABLE(debuginfo,
-[--enable-debuginfo - Enable support for debuggers],,enable_debuginfo=no)
-
-AC_ARG_ENABLE(smpcoll,
-	[--enable-smpcoll - Enable support for SMP/multi-core aware collectives],
-	smpcoll=$enableval,
-	smpcoll=yes)
+AC_ARG_ENABLE([f77],
+              AS_HELP_STRING([--enable-f77], [Enable Fortran 77 bindings]),,
+              enable_f77=default; enable_f77_wasdefault=yes)
+AC_ARG_ENABLE([f90],
+              AS_HELP_STRING([--enable-f90], [Enable Fortran 90 bindings]),,
+              enable_f90=default)
+AC_ARG_ENABLE([cxx]
+              AS_HELP_STRING([--enable-cxx], [Enable C++ bindings]),,
+              enable_cxx=default)
+AC_ARG_ENABLE([romio],
+              AS_HELP_STRING([--enable-romio],
+                             [Enable ROMIO MPI I/O implementation]),
+              ,enable_romio=yes)
+dnl
+AC_ARG_ENABLE([debuginfo],
+              AS_HELP_STRING([--enable-debuginfo],
+                             [Enable support for debuggers]),,
+              enable_debuginfo=no)
+
+AC_ARG_ENABLE([smpcoll],
+             AS_HELP_STRING([--enable-smpcoll],
+                            [Enable support for SMP/multi-core aware collectives]),
+             smpcoll=$enableval,
+             smpcoll=yes)
 
 if test $smpcoll = "yes" ; then
-   AC_DEFINE(USE_SMP_COLLECTIVES,1,[define to enable SMP/multi-core aware collectives])
+   AC_DEFINE([USE_SMP_COLLECTIVES],1,[define to enable SMP/multi-core aware collectives])
 fi
 
-AC_ARG_ENABLE(async-progress,
-	[--enable-async-progress - Enable support for asynchronous communication progress],
-	async_progress=$enableval,async_progress=no)
+AC_ARG_ENABLE([async-progress],
+	     AS_HELP_STRING([--enable-async-progress],
+	                    [Enable support for asynchronous communication progress]),
+	      async_progress=$enableval,async_progress=no)
 if test "$async_progress" = "yes" ; then
-   AC_DEFINE(USE_ASYNC_PROGRESS,1,[define to enable asynchronous communication progress])
+   AC_DEFINE([USE_ASYNC_PROGRESS],1,[define to enable asynchronous communication progress])
 fi
 
 dnl The environment variable MPICH_DEBUGLIBNAME may be used to override the
 dnl default name of the library that the debugger will load to access the
 dnl MPICH2 internal data structures.
 dnl
-AC_ARG_ENABLE(nmpi-as-mpi,
-[--enable-nmpi-as-mpi - Use MPI rather than PMPI routines for MPI
-                       routines, such as the collectives, that may be
-                       implemented in terms of other MPI routines]
-  ,,enable_nmpi_as_mpi=no)
+AC_ARG_ENABLE([nmpi-as-mpi],
+              AS_HELP_STRING([--enable-nmpi-as-mpi],
+                             [Use MPI rather than PMPI routines for MPI
+                                routines, such as the collectives, that may be
+                                implemented in terms of other MPI routines]),,
+              enable_nmpi_as_mpi=no)
 
 dnl
 dnl With options
 dnl "default" is a special device that allows MPICH to choose one based on 
 dnl the environment.
-AC_ARG_WITH(device,
-[--with-device=name - Specify the communication device for MPICH.],,
-with_device=default)
-dnl
-AC_ARG_WITH(pmi, [--with-pmi=name - Specify the pmi interface for MPICH.],,
-with_pmi=default)
-dnl
-AC_ARG_WITH(pm, 
-[--with-pm=name - Specify the process manager for MPICH.  "no" or "none" are
-                  valid values.  Multiple process managers may be specified as
-                  long as they all use the same pmi interface by separating them
-                  with colons.  The mpiexec for the first named process manager
-                  will be installed.  Example: "--with-pm=gforker:mpd:remshell"
-                  builds the three process managers gforker, mpd, and remshell;
-                  only the mpiexec from gforker is installed into the bin
-                  directory.]
-    ,,with_pm=default)
-dnl
-AC_ARG_WITH(logging,
-[--with-logging=name - Specify the logging library for MPICH.],
-[if test -z "$withval" ; then with_logging=rlog ; fi],
-with_logging=none)
+AC_ARG_WITH([device],
+           AS_HELP_STRING([--with-device=name], [Specify the communication device for MPICH.]),,
+           with_device=default)
+dnl
+AC_ARG_WITH([pmi], AS_HELP_STRING([--with-pmi=name],
+                                  [Specify the pmi interface for MPICH.]),,
+           with_pmi=default)
+dnl
+AC_ARG_WITH([pm],
+            AS_HELP_STRING([--with-pm=name],
+              [- Specify the process manager for MPICH.  "no" or "none" are
+               valid values.  Multiple process managers may be specified as
+               long as they all use the same pmi interface by separating them
+               with colons.  The mpiexec for the first named process manager
+               will be installed.  Example: "--with-pm=gforker:mpd:remshell"
+               builds the three process managers gforker, mpd, and remshell;
+               only the mpiexec from gforker is installed into the bin
+               directory.]),,
+            with_pm=default)
+dnl
+AC_ARG_WITH([logging],
+            AS_HELP_STRING([--with-logging=name],
+                           [Specify the logging library for MPICH.]),
+            [if test -z "$withval" ; then with_logging=rlog ; fi],
+            with_logging=none)
 dnl 
 dnl both --without-mpe and --disable-mpe are supported
 dnl AC_ARG_ENABLE(mpe) is used only when --with(out)-mpe is not used.
-AC_ARG_WITH(mpe,
-[--with-mpe - Build the MPE (MPI Parallel Environment) routines],,
-with_mpe=default)
+AC_ARG_WITH([mpe],
+           AS_HELP_STRING([--with-mpe],
+                          [Build the MPE (MPI Parallel Environment) routines]),,
+           with_mpe=default)
+
 if test "$with_mpe" = "default" ; then
-    AC_ARG_ENABLE(mpe,
-    [--enable-mpe - Build the MPE (MPI Parallel Environment) routines],
-    with_mpe=$enableval,with_mpe=default)
-fi
-dnl
-AC_ARG_ENABLE(threads,
-[--enable-threads=level - Control the level of thread support in the 
-                         MPICH implementation.  The following levels
-                         are supported.
-    default         - Choose thread level at runtime based on parameters 
-                      passed to MPI_Init_thread (default)
-    single          - No threads (MPI_THREAD_SINGLE)
-    funneled        - Only the main thread calls MPI (MPI_THREAD_FUNNELED)
-    serialized      - User serializes calls to MPI (MPI_THREAD_SERIALIZED)
-    multiple(:impl) - Fully multi-threaded (MPI_THREAD_MULTIPLE). DO NOT
-                      select this option. The default option is more
-                      efficient and also supports thread_multiple.
-
-      The following implementations are supported.
-          global_mutex - a single global lock guards access to all 
-	                 MPI functions.
-      The default implementation is global_mutex.
-
-    For the ch3:sock and ch3:nemesis channels, a separate build is no
-    longer needed for thread-multiple.  It is compiled by default and
-    is selectable at run time with MPI_Init_thread.  If
-    MPI_Init_thread is not called, the default is funneled.  For
-    other channels, the --enable-threads option is not supported
-    currently, and the default is funneled.]
+    AC_ARG_ENABLE([mpe],
+                  AS_HELP_STRING([--enable-mpe],
+                                 [Build the MPE (MPI Parallel Environment) routines]),
+                  with_mpe=$enableval,with_mpe=default)
+fi
+dnl
+AC_ARG_ENABLE([threads],
+              AS_HELP_STRING([--enable-threads=level],
+                             [Control the level of thread support in the
+                                MPICH implementation.  The following levels
+                                are supported.
+              default         - Choose thread level at runtime based on parameters
+                                passed to MPI_Init_thread (default)
+              single          - No threads (MPI_THREAD_SINGLE)
+              funneled        - Only the main thread calls MPI (MPI_THREAD_FUNNELED)
+              serialized      - User serializes calls to MPI (MPI_THREAD_SERIALIZED)
+              multiple(:impl) - Fully multi-threaded (MPI_THREAD_MULTIPLE). DO NOT
+                                select this option. The default option is more
+                                efficient and also supports thread_multiple.
+
+              The following implementations are supported.
+              global_mutex - a single global lock guards access to all
+	                     MPI functions.
+	      The default implementation is global_mutex.
+
+              For the ch3:sock and ch3:nemesis channels, a separate build is no
+              longer needed for thread-multiple.  It is compiled by default and
+              is selectable at run time with MPI_Init_thread.  If
+              MPI_Init_thread is not called, the default is funneled.  For
+              other channels, the --enable-threads option is not supported
+              currently, and the default is funneled.])
     ,
     , 
     enable_threads=default)
 
 dnl
-AC_ARG_ENABLE(thread-cs,
-[--enable-thread-cs=type - Choose the method used for critical
-                          sections and other atomic updates when
-                          multiple threads are present.  Values may
-                          be global (default), per-object, lock-free]
+AC_ARG_ENABLE([thread-cs],
+              AS_HELP_STRING([--enable-thread-cs=type],
+                             [Choose the method used for critical
+                              sections and other atomic updates when
+                              multiple threads are present.  Values may
+                              be global (default), per-object, lock-free])
  , , enable_thread_cs=global)
 
-AC_ARG_ENABLE(refcount,
-[--enable-refcount=type - Choose the method for ensuring atomic
-                         updates to the reference counts for MPI
-                         objects.  Values may be lock, lock-free,
-                         none.  The default depends on the thread-cs
-                         choice; for global it is none (because none
-                         is required), for per-object it is lock, and for
-                         lock-free it is lock-free]
+AC_ARG_ENABLE([refcount],
+              AS_HELP_STRING([--enable-refcount=type],
+                             [Choose the method for ensuring atomic
+                              updates to the reference counts for MPI
+                              objects.  Values may be lock, lock-free,
+                              none.  The default depends on the thread-cs
+                              choice; for global it is none (because none
+                              is required), for per-object it is lock, and for
+                              lock-free it is lock-free])
     ,,enable_refcount=default)
 
-AC_ARG_ENABLE(mutex-timing, [--enable-mutex-timing - calculate the time spent waiting on mutexes.],
-    AC_DEFINE(MPIU_MUTEX_WAIT_TIME,1,[Define to enable timing mutexes])
+AC_ARG_ENABLE([mutex-timing], AS_HELP_STRING([--enable-mutex-timing],
+                                             [calculate the time spent waiting on mutexes.]),
+    AC_DEFINE([MPIU_MUTEX_WAIT_TIME],1,[Define to enable timing mutexes])
  )
 
-AC_ARG_ENABLE(handle-allocation,
-[--enable-handle-allocation=type - Choose the method used for
-                                  allocating MPI object handles.
-                                  Values may be 'tls' for thread-local
-                                  storage or 'mutex' for simple
-                                  locking.  'mutex' is the default.]
+AC_ARG_ENABLE([handle-allocation]
+              AS_HELP_STRING([--enable-handle-allocation=type],
+                             [Choose the method used for allocating MPI object handles.
+                              Values may be 'tls' for thread-local storage or 'mutex' for
+                              simple locking.  'mutex' is the default.])
     ,, enable_handle_allocation=default)
 
 dnl 
 dnl
-AC_ARG_ENABLE(weak-symbols,
-[--enable-weak-symbols - Use weak symbols to implement PMPI routines (default)],,
+AC_ARG_ENABLE([weak-symbols],
+              AS_HELP_STRING([--enable-weak-symbols],
+                             [Use weak symbols to implement PMPI routines (default)]),,
 enable_weak_symbols=yes)
 dnl
 dnl
 dnl
-AC_ARG_WITH(cross,
-[--with-cross=file - Specify the values of variables that configure cannot
-                    determine in a cross-compilation environment]
+AC_ARG_WITH([cross],
+           AS_HELP_STRING([--with-cross=file],
+                          [Specify the values of variables that configure cannot
+                           determine in a cross-compilation environment])
     ,,with_cross=no)
 dnl
-AC_ARG_WITH(namepublisher,
-[--with-namepublisher=name - Choose the system that will support 
-                             MPI_PUBLISH_NAME and MPI_LOOKUP_NAME.  Options
-                             include
-                               no (no service available)
-                               mpd
-			       file[:directory] (optional directory)
-			       ],,
+AC_ARG_WITH([namepublisher],
+            AS_HELP_STRING([--with-namepublisher=name],
+                           [Choose the system that will support MPI_PUBLISH_NAME and
+                            MPI_LOOKUP_NAME.  Options include
+                             no (no service available)
+                             mpd
+			     file[:directory] (optional directory)]),,
 with_namepublisher=default)
 dnl
 dnl AC_ARG_WITH(cxxlibname,
@@ -528,15 +560,16 @@ dnl
 dnl AC_ARG_WITH(flibname,
 dnl [--with-flibname=name  - Specify name of library containing Fortran interface
 dnl routines],[MPIFLIBNAME=$withval;set_MPIFLIBNAME="yes"],MPIFLIBNAME=)
-AC_SUBST(MPIFLIBNAME)
-AC_SUBST(PMPIFLIBNAME)
+AC_SUBST([MPIFLIBNAME])
+AC_SUBST([PMPIFLIBNAME])
 dnl
 dnl The default is a special wrapper library
-AC_ARG_WITH(fwrapname,
-[--with-fwrapname=name - Specify name of library containing Fortran interface
-                        routines]
+AC_ARG_WITH([fwrapname],
+            AS_HELP_STRING([--with-fwrapname=name],
+                           [Specify name of library containing Fortran interface
+                            routines])
     ,[FWRAPNAME=$withval;set_FWRAPNAME="yes"],FWRAPNAME=fmpich)
-AC_SUBST(FWRAPNAME)
+AC_SUBST([FWRAPNAME])
 
 
 dnl
@@ -605,8 +638,8 @@ fi
 if test -z "$master_top_builddir" ; then
    master_top_builddir="`pwd`"
 fi
-AC_SUBST(master_top_builddir)
-AC_SUBST(master_top_srcdir)
+AC_SUBST([master_top_builddir])
+AC_SUBST([master_top_srcdir])
 export master_top_builddir
 export master_top_srcdir
 # ----------------------------------------------------------------------------
@@ -625,7 +658,7 @@ fi
 # included directories
 # 
 DEVICE=$with_device
-AC_SUBST(DEVICE)
+AC_SUBST([DEVICE])
 
 device_name=`echo $with_device | sed -e 's/:.*$//'`
 changequote(<<,>>)
@@ -651,9 +684,9 @@ export device_args
 export devicedir
 # Make the device base name and args available to generated files
 DEVICE_NAME=$device_name
-AC_SUBST(DEVICE_NAME)
+AC_SUBST([DEVICE_NAME])
 DEVICE_ARGS=$device_args
-AC_SUBST(DEVICE_ARGS)
+AC_SUBST([DEVICE_ARGS])
 
 dnl <_OSU_MVAPICH_>
 if test -z "$enable_mvapich"; then
@@ -672,14 +705,14 @@ if test "$with_device" = "ch3:psm"; then
 fi
 
 if test "$enable_psm_mvapich" = "yes"; then
-    AC_DEFINE(_OSU_PSM_,1,[Define to enable MVAPICH2-PSM customizations.])
+    AC_DEFINE([_OSU_PSM_],1,[Define to enable MVAPICH2-PSM customizations.])
 fi
 
 if test "$enable_mvapich" = "yes"; then
-    AC_DEFINE(_OSU_MVAPICH_,1,[Define to enable MVAPICH2 customizations.])
-    AC_DEFINE(MPIDI_CH3_CHANNEL_RNDV,1,[Define to enable channel rendezvous (Required by MVAPICH2).])
-    AC_DEFINE(MPID_USE_SEQUENCE_NUMBERS,1,[Define to enable use of sequence numbers (Required by MVAPICH2).])
-    AC_DEFINE(_OSU_COLLECTIVES_,1,[Define to enable the use of MVAPICH2 implmentation of collectives])
+    AC_DEFINE([_OSU_MVAPICH_],1,[Define to enable MVAPICH2 customizations.])
+    AC_DEFINE([MPIDI_CH3_CHANNEL_RNDV],1,[Define to enable channel rendezvous (Required by MVAPICH2).])
+    AC_DEFINE([MPID_USE_SEQUENCE_NUMBERS],1,[Define to enable use of sequence numbers (Required by MVAPICH2).])
+    AC_DEFINE([_OSU_COLLECTIVES_],1,[Define to enable the use of MVAPICH2 implmentation of collectives])
 
     # Enable header caching by default.
     if test -z "$enable_header_caching"; then
@@ -688,7 +721,7 @@ if test "$enable_mvapich" = "yes"; then
     fi
 
     if test "$enable_header_caching" = "yes"; then
-        AC_DEFINE(USE_HEADER_CACHING,1,[Define to enable header caching.])
+        AC_DEFINE([USE_HEADER_CACHING],1,[Define to enable header caching.])
     fi
 fi
 
@@ -708,7 +741,7 @@ if test "$enable_nemesis_ib" = "yes"; th
     fi
 
     if test "$enable_header_caching" = "yes"; then
-        AC_DEFINE(USE_HEADER_CACHING,1,[Define to enable header caching.])
+        AC_DEFINE([USE_HEADER_CACHING],1,[Define to enable header caching.])
     fi
 fi
 
@@ -720,7 +753,7 @@ dnl </_OSU_MVAPICH_>
 # device's mpich2prereq script.  The device's script may override the value
 # if needed.
 INCLUDE_MPIDDEFS_H='/* ... no device specific definitions ... */'
-AC_SUBST(INCLUDE_MPIDDEFS_H)
+AC_SUBST([INCLUDE_MPIDDEFS_H])
 
 #
 # See if the device wants to say something about the compilers (for example,
@@ -746,7 +779,7 @@ if test -z "$MPICXXLIBNAME" ; then MPICX
 export MPIFLIBNAME
 export PMPIFLIBNAME
 export MPICXXLIBNAME
-AC_SUBST(MPICXXLIBNAME)
+AC_SUBST([MPICXXLIBNAME])
 
 # We'll set FORTRAN_BINDING to 1 if we support Fortran 
 FORTRAN_BINDING=0
@@ -840,7 +873,7 @@ case "$enable_error_checking" in
     error_checking_kind=`echo $enable_error_checking | \
     tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
     error_checking_kind=MPID_ERROR_LEVEL_$error_checking_kind
-    AC_DEFINE_UNQUOTED(HAVE_ERROR_CHECKING,$error_checking_kind,[Define to enable error checking])
+    AC_DEFINE_UNQUOTED([HAVE_ERROR_CHECKING],$error_checking_kind,[Define to enable error checking])
     ;;
     *)
     AC_MSG_WARN([Unknown value $enable_error_checking for enable-error-checking])
@@ -865,7 +898,7 @@ case "$enable_error_messages" in
     AC_MSG_WARN([Unknown value $enable_error_messages for enable-error-messages])
     ;;
 esac
-AC_DEFINE_UNQUOTED(MPICH_ERROR_MSG_LEVEL,$error_message_kind,[define to enable error messages])
+AC_DEFINE_UNQUOTED([MPICH_ERROR_MSG_LEVEL],$error_message_kind,[define to enable error messages])
 
 # ----------------------------------------------------------------------------
 #
@@ -1040,11 +1073,11 @@ if test "$timing_name" != "none" ; then
     fi
 fi
 #
-AC_SUBST(logging_dir)
-AC_SUBST(logging_name)
-AC_SUBST(logging_subdirs)
+AC_SUBST([logging_dir])
+AC_SUBST([logging_name])
+AC_SUBST([logging_subdirs])
 use_logging_variable="MPID_LOGGING_`echo $logging_name | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`"
-AC_DEFINE_UNQUOTED(USE_LOGGING,$use_logging_variable,[define to choose logging library])
+AC_DEFINE_UNQUOTED([USE_LOGGING],$use_logging_variable,[define to choose logging library])
 # ----------------------------------------------------------------------------
 # End of logging tests
 # ----------------------------------------------------------------------------
@@ -1110,7 +1143,7 @@ elif test "$enable_threads" = "default";
 fi
 # Runtime is an alias for multiple with an additional value
 if test "$enable_threads" = "runtime" ; then
-    AC_DEFINE(HAVE_RUNTIME_THREADCHECK,1,[Define if MPI supports MPI_THREAD_MULTIPLE with a runtime check for thread level])
+    AC_DEFINE([HAVE_RUNTIME_THREADCHECK],1,[Define if MPI supports MPI_THREAD_MULTIPLE with a runtime check for thread level])
     enable_threads=multiple
     # FIXME: This doesn't support runtime:thread-impl (as in multiple:thread-impl)
 fi
@@ -1192,11 +1225,11 @@ if test "$threadLevelOK" != yes ; then
 fi
 
 export MPICH_THREAD_LEVEL
-AC_DEFINE_UNQUOTED(MPICH_THREAD_LEVEL,$MPICH_THREAD_LEVEL,[Level of thread support selected at compile time])
+AC_DEFINE_UNQUOTED([MPICH_THREAD_LEVEL],$MPICH_THREAD_LEVEL,[Level of thread support selected at compile time])
 
 MPICH_THREAD_IMPL="MPICH_THREAD_IMPL_`echo $thread_impl | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`"
 export MPICH_THREAD_IMPL
-AC_DEFINE_UNQUOTED(USE_THREAD_IMPL,$MPICH_THREAD_IMPL,[Multi-threaded implementation selected at compile time])
+AC_DEFINE_UNQUOTED([USE_THREAD_IMPL],$MPICH_THREAD_IMPL,[Multi-threaded implementation selected at compile time])
 
 if test "$thread_pkg_required" = "no" ; then
     MPIU_THREAD_DEFAULT=${MPIU_THREAD_DEFAULT:-none}
@@ -1277,7 +1310,7 @@ for option in $enable_g ; do
 	perform_handlealloc=yes
 	;;
 	handle)
-	AC_DEFINE(MPICH_DEBUG_HANDLES,1,[Define to enable handle checking])
+	AC_DEFINE([MPICH_DEBUG_HANDLES],1,[Define to enable handle checking])
 	;;
 	meminit)
 	perform_meminit=yes
@@ -1340,38 +1373,38 @@ if test "$enable_append_ndebug" = "yes"
     F90FLAGS="$F90FLAGS -DNDEBUG"
 fi
 if test -n "$perform_meminit" ; then
-    AC_DEFINE(MPICH_DEBUG_MEMINIT,1,[Define to enable preinitialization of memory used by structures and unions])
+    AC_DEFINE([MPICH_DEBUG_MEMINIT],1,[Define to enable preinitialization of memory used by structures and unions])
 fi
 if test "$perform_handlealloc" = yes ; then
-   AC_DEFINE(MPICH_DEBUG_HANDLEALLOC,1,[Define to enable checking of handles still allocated at MPI_Finalize])
+   AC_DEFINE([MPICH_DEBUG_HANDLEALLOC],1,[Define to enable checking of handles still allocated at MPI_Finalize])
 fi
 
 if test -n "$perform_memtracing" ; then
     enable_g_mem=yes
-    AC_DEFINE(USE_MEMORY_TRACING,1,[Define to enable memory tracing])
+    AC_DEFINE([USE_MEMORY_TRACING],1,[Define to enable memory tracing])
     if test -n "$perform_memarena" ; then
-        AC_DEFINE(MPICH_DEBUG_MEMARENA,1,[Define if each function exit should confirm memory arena correctness])
+        AC_DEFINE([MPICH_DEBUG_MEMARENA],1,[Define if each function exit should confirm memory arena correctness])
     fi
 fi
 if test -n "$perform_nesttesting" ; then
-    AC_DEFINE(MPICH_DEBUG_NESTING,1,[Define to check nesting level on exit])
+    AC_DEFINE([MPICH_DEBUG_NESTING],1,[Define to check nesting level on exit])
 fi
 if test -n "$perform_mutexnesting" ; then 
-    AC_DEFINE(MPICH_DEBUG_MUTEXNESTING,1,[Define to check nesting in mutexes])
+    AC_DEFINE([MPICH_DEBUG_MUTEXNESTING],1,[Define to check nesting in mutexes])
 fi
 if test -n "$perform_fg_nesttesting" ; then
-    AC_DEFINE(MPICH_DEBUG_FINE_GRAIN_NESTING,1,[Define to perform a fine-grain nesting level check on exit])
+    AC_DEFINE([MPICH_DEBUG_FINE_GRAIN_NESTING],1,[Define to perform a fine-grain nesting level check on exit])
 fi
 if test -n "$perform_dbglog" ; then
    if test "$with_logging" != "none" ; then
        AC_MSG_WARN([--with-logging overrides --enable-g=log])
    else
-       AC_DEFINE(USE_DBG_LOGGING,1,[Define to enable logging macros])
+       AC_DEFINE([USE_DBG_LOGGING],1,[Define to enable logging macros])
    fi
 fi
 
 if test -n "$perform_dbgmutex" ; then 
-   AC_DEFINE(MPICH_DEBUG_MUTEX,1,[Define to enable mutex debugging])
+   AC_DEFINE([MPICH_DEBUG_MUTEX],1,[Define to enable mutex debugging])
 fi
 
 pac_cross_compiling=no
@@ -1399,7 +1432,7 @@ if test "$with_cross" != "no" ; then
 fi
 
 if test "$enable_nmpi_as_mpi" = yes ; then
-   AC_DEFINE(USE_MPI_FOR_NMPI,1,[Define if the NMPI names should use MPI instead of PMPI])
+   AC_DEFINE([USE_MPI_FOR_NMPI],1,[Define if the NMPI names should use MPI instead of PMPI])
 fi
 
 # This goes here because we need the top_srcdir
@@ -1408,10 +1441,10 @@ export FROM_MPICH2
 if test "$enable_romio" = "yes" ; then
    if test -d $use_top_srcdir/src/mpi/romio ; then
        subsystems="$subsystems src/mpi/romio"
-       AC_DEFINE(HAVE_ROMIO,1,[Define if ROMIO is enabled])
+       AC_DEFINE([HAVE_ROMIO],1,[Define if ROMIO is enabled])
        # Set environment variables that the romio configure expects
        romio_dir=romio
-       AC_SUBST(romio_dir)
+       AC_SUBST([romio_dir])
        export use_top_srcdir
        top_build_dir=`pwd`
        export top_build_dir
@@ -1451,7 +1484,7 @@ fi
 if test -n "$device_name" -a "$INSTALL_FROM_DEVICE" = yes ; then
     other_install_dirs="${other_install_dirs} $devicereldir"
 fi
-AC_SUBST(device_name)
+AC_SUBST([device_name])
 #
 # with-pm
 if test "$with_pm" = "none" ; then
@@ -1479,7 +1512,7 @@ fi
 # We allow multiple pm names, separated by : or ,
 # If multiple PMs are provided, we set the value MANY_PM to yes
 MANY_PM=no
-AC_SUBST(MANY_PM)
+AC_SUBST([MANY_PM])
 if test "$with_pm" != "no" ; then
     pm_names="`echo $with_pm | sed -e 's/:/ /g' -e 's/,/ /g'`"
 else
@@ -1547,13 +1580,13 @@ fi
 #
 # pm_name is the *primary* pm
 pm_name=$first_pm_name
-AC_SUBST(pm_name)
-AC_SUBST(other_pm_names)
+AC_SUBST([pm_name])
+AC_SUBST([other_pm_names])
 
 # Some versions of PM and PMI require a special definition (currently, only
 # smpd requires this)
 if test "$PMI_REQUIRES_READABLE_TOKENS" = "yes" ; then
-    AC_DEFINE(USE_HUMAN_READABLE_TOKENS,1,[Define to use ='s and spaces in the string utilities.])
+    AC_DEFINE([USE_HUMAN_READABLE_TOKENS],1,[Define to use ='s and spaces in the string utilities.])
 fi
 
 if test -n "$first_pm_name" ; then
@@ -1596,7 +1629,7 @@ elif test "$with_pmi" != "no" ; then
 else
     AC_MSG_ERROR([A PMI implementation must be selected or the default used.])
 fi
-AC_SUBST(pmi_name)
+AC_SUBST([pmi_name])
 
 # Step 3: complete pm setup.
 # Note that checks for errors have already been performed, so this
@@ -1659,8 +1692,8 @@ if test $with_mpe != no ; then
         export top_build_dir
     fi
 fi
-AC_SUBST(mpe_dir)
-AC_SUBST(other_install_dirs)
+AC_SUBST([mpe_dir])
+AC_SUBST([other_install_dirs])
 
 dnl
 dnl The recommended order for items in a configure.in file is
@@ -1777,7 +1810,9 @@ dnl </_OSU_MVAPICH_>
 # bindings tests.
 # Set CFLAGS for enable strict if necessary.  Do this *first* because
 # it may influence the output of the other tests
-AC_ARG_ENABLE(strict,[--enable-strict - Turn on strict debugging with gcc],,enable_strict=no)
+AC_ARG_ENABLE([strict],
+             AS_HELP_STRING([--enable-strict].
+                            [- Turn on strict debugging with gcc]),,enable_strict=no)
 PAC_CC_STRICT($enable_strict)
 if test -n "$pac_cc_strict_flags" ; then
     CFLAGS="$CFLAGS $pac_cc_strict_flags"
